/* νꤹ뤿Υ⥸塼 */
#ifndef _ordering_h_included_
#define _ordering_h_included_

#include "anthy/segclass.h"		/* Patched by G-HAL, Sat,25 Apr,2008 */
#include "anthy/splitter.h"		/* Patched by G-HAL, Tue,20 Jul,2010 */
#include <anthy/xstr.h>

#ifdef __cplusplus
extern "C" {
#endif

struct segment_list;
struct splitter_context;

/** ordering_contextwrapper¤
 */
struct ordering_context_wrapper{
  struct ordering_context *oc;
};

#if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
void anthy_proc_commit(struct segment_list *, struct splitter_context *);
#else
extern void anthy_proc_commit( struct segment_list* sl, struct splitter_context* sc, int learn );
#endif

extern int anthy_mw_eval( const struct seg_dep_info_t* const prev_commit, struct meta_word* const mw, int with_corpus );	/* Patched by G-HAL, Wed,04 Feb,2009, Tue,20 Jul,2010 - Wed,21 Jul,2010 */

#if 0	/* Patched by G-HAL, Sat,25 Apr,2009, Thu,12 Nov,2009, Tue,20 Jul,2010 - Wed,21 Jul,2010 */
void anthy_sort_candidate(struct segment_list *c, int nth);
void anthy_sort_metaword(struct segment_list *seg);
#else
extern void anthy_sort_candidate( struct splitter_context* const sc, struct segment_list* const sl, int nth );
extern void anthy_sort_metaword( const struct seg_dep_info_t* const prev_commit, struct segment_list* const seg_list );
#endif

void anthy_do_commit_prediction(xstr *src, xstr *xs);

/**/
void anthy_infosort_init(void);
void anthy_relation_init(void);

#ifdef __cplusplus
}
#endif

#endif
